]> sipb.mit.edu Git - ikiwiki.git/blobdiff - IkiWiki/Plugin/aggregate.pm
aggregate.pm: Replace Unicode apostrophe with ASCII to unbreak build
[ikiwiki.git] / IkiWiki / Plugin / aggregate.pm
index 21c83e34a6f3fa6ddee43fc127e582ab037e7abb..71368e254a960cf2545efe79ffe4b91601b34649 100644 (file)
@@ -37,14 +37,25 @@ sub checkconfig () { #{{{
                        debug("wiki is locked by another process, not aggregating");
                        exit 1;
                }
-       
-               loadstate();
-               IkiWiki::loadindex();
-               aggregate();
-               expire();
-               savestate();
-               clearstate();
-
+               
+               # Fork a child process to handle the aggregation.
+               # The parent process will then handle building the result.
+               # This avoids messy code to clear state accumulated while
+               # aggregating.
+               defined(my $pid = fork) or error("Can't fork: $!");
+               if (! $pid) {
+                       loadstate();
+                       IkiWiki::loadindex();
+                       aggregate();
+                       expire();
+                       savestate();
+                       exit 0;
+               }
+               waitpid($pid,0);
+               if ($?) {
+                       error "aggregation failed with code $?";
+               }
+               
                IkiWiki::unlockwiki();
        }
 } #}}}
@@ -129,6 +140,7 @@ sub delete (@) { #{{{
 my $state_loaded=0;
 sub loadstate () { #{{{
        return if $state_loaded;
+       $state_loaded=1;
        if (-e "$config{wikistatedir}/aggregate") {
                open(IN, "$config{wikistatedir}/aggregate") ||
                        die "$config{wikistatedir}/aggregate: $!";
@@ -159,8 +171,6 @@ sub loadstate () { #{{{
                }
 
                close IN;
-               
-               $state_loaded=1;
        }
 } #}}}
 
@@ -212,12 +222,6 @@ sub savestate () { #{{{
                error("rename $newfile: $!", $cleanup);
 } #}}}
 
-sub clearstate () { #{{{
-       %feeds=();
-       %guids=();
-       $state_loaded=0;
-} #}}}
-
 sub expire () { #{{{
        foreach my $feed (values %feeds) {
                next unless $feed->{expireage} || $feed->{expirecount};
@@ -302,6 +306,13 @@ sub aggregate () { #{{{
                        $content=Encode::decode_utf8($content);
                        $f=eval{XML::Feed->parse(\$content)};
                }
+               if ($@) {
+                       # Another possibility is badly escaped entities.
+                       $feed->{message}.=" ".sprintf(gettext("(feed entities escaped)"));
+                       $content=~s/\&(?!amp)(\w+);/&$1;/g;
+                       $content=Encode::decode_utf8($content);
+                       $f=eval{XML::Feed->parse(\$content)};
+               }
                if ($@) {
                        $feed->{message}=gettext("feed crashed XML::Feed!")." ($@)";
                        $feed->{error}=1;
@@ -318,6 +329,7 @@ sub aggregate () { #{{{
                foreach my $entry ($f->entries) {
                        add_page(
                                feed => $feed,
+                               copyright => $f->copyright,
                                title => defined $entry->title ? decode_entities($entry->title) : "untitled",
                                link => $entry->link,
                                content => defined $entry->content->body ? $entry->content->body : "",
@@ -397,6 +409,8 @@ sub add_page (@) { #{{{
        $template->param(content => htmlescape(htmlabs($params{content}, $feed->{feedurl})));
        $template->param(name => $feed->{name});
        $template->param(url => $feed->{url});
+       $template->param(copyright => $params{copyright})
+               if defined $params{copyright} && length $params{copyright};
        $template->param(permalink => urlabs($params{link}, $feed->{feedurl}))
                if defined $params{link};
        if (ref $feed->{tags}) {
@@ -407,7 +421,8 @@ sub add_page (@) { #{{{
 
        # Set the mtime, this lets the build process get the right creation
        # time on record for the new page.
-       utime $mtime, $mtime, pagefile($guid->{page}) if defined $mtime;
+       utime $mtime, $mtime, pagefile($guid->{page})
+               if defined $mtime && $mtime <= time;
 } #}}}
 
 sub htmlescape ($) { #{{{